> ## Documentation Index > Fetch the complete documentation index at: https://docs.mapp.com/llms.txt > Use this file to discover all available pages before exploring further. # Get a prepared message > Returns a prepared message identified by messageId. Omit contactId or leave it empty to get the raw (not personalized) message. When contactId is provided, the message is personalized for that contact, who must be a member of the prepared message's group. If the contact has no email address, email personalization is skipped and the email HTML/text remains raw (not personalized).

trackingOverride controls message tracking consent override behavior:
1 = no override; per-contact tracking consent applies.
2 = full override; open and link-click tracking are enforced for all recipients regardless of individual consent.
3 = anonymized aggregate tracking for recipients whose consent is denied or withdrawn.
Any other value is rejected by this API. ## OpenAPI ````json GET /preparedmessage/get { "openapi": "3.0.4", "info": { "title": "Engage public API", "version": "1" }, "servers": [ { "url": "https://your-engage-domain.com/api/rest" } ], "tags": [ { "name": "Address Attributes" }, { "name": "Async" }, { "name": "Audit Log" }, { "name": "Automation" }, { "name": "Blacklist" }, { "name": "CMS" }, { "name": "Contact" }, { "name": "Content" }, { "name": "Coupon" }, { "name": "Draft Message" }, { "name": "Ecommerce" }, { "name": "Group" }, { "name": "Group Attributes" }, { "name": "Landing Page" }, { "name": "Member Attributes" }, { "name": "Membership" }, { "name": "Message" }, { "name": "Meta" }, { "name": "Mobile Push" }, { "name": "Prepared Message" }, { "name": "Process" }, { "name": "Profile Attributes" }, { "name": "Related Data" }, { "name": "Segmentation" }, { "name": "System" }, { "name": "System User" }, { "name": "Usage Statistics" }, { "name": "User" }, { "name": "Whiteboard" } ], "paths": { "/preparedmessage/get": { "get": { "tags": [ "Prepared Message" ], "summary": "Get a prepared message", "description": "Returns a prepared message identified by messageId. Omit contactId or leave it empty to get the raw (not personalized) message. When contactId is provided, the message is personalized for that contact, who must be a member of the prepared message's group. If the contact has no email address, email personalization is skipped and the email HTML/text remains raw (not personalized).

trackingOverride controls message tracking consent override behavior:
1 = no override; per-contact tracking consent applies.
2 = full override; open and link-click tracking are enforced for all recipients regardless of individual consent.
3 = anonymized aggregate tracking for recipients whose consent is denied or withdrawn.
Any other value is rejected by this API.", "operationId": "GetPreparedMessage", "parameters": [ { "name": "messageId", "in": "query", "description": "The prepared message ID", "required": true, "schema": { "type": "integer", "format": "int64" } }, { "name": "contactId", "in": "query", "description": "Optional contact ID for personalization. Omit or leave empty to get the raw (not personalized) message. When provided, the contact must be a member of the prepared message's group. If the contact has no email address, the email HTML/text remains raw (not personalized).", "schema": { "type": "integer", "format": "int64" } } ], "responses": { "200": { "description": "{
\"contactId\": 45802709,
\"messageId\": 7579,
\"name\": \"JohnPreparedWithCustom20220215\",
\"groupId\": 3302,
\"groupName\": \"John20220208\",
\"selectionId\": null,
\"selectionName\": null,
\"channelId\": 327699,
\"channelName\": \"DMC Email\",
\"externalId\": null,
\"messageCategoryId\": null,
\"messageCategoryName\": null,
\"trackingOverride\": 2,
\"message\": {
\"subject\": \"JohnPreparedWithCustom20220215\",
\"emailBodyText\": null,
\"emailBodyHtml\": \"JohnPreparedWithCustom20220215\\r\\nEmail(standard) tt7177798@gmail.comtt7178198@gmail.com\\r\\nEmail(Custom) OBFUSCATEDtt71778198@gmail.com<\\/body><\\/html>\",
\"smsText\": null,
\"faxText\": null,
\"emailHeaders\": [],
\"attachments\": [],
\"attachmentReferences\": null,
\"encoding\": \"ISO-8859-1\",
\"encodingSMS\": \"ISO-8859-1\",
\"imageHandlingMode\": \"none\"
}
}", "content": { "application/octet-stream": { "schema": { "$ref": "#/components/schemas/PreparedMessage" } } } }, "400": { "description": "Please enter a valid prepared message ID, Please enter a valid test contact ID to get the personalized HTML, No membership for user '25493969' in group '2186' found.", "content": { "application/octet-stream": {} } } } } } }, "components": { "schemas": { "PreparedMessage": { "type": "object", "properties": { "contactId": { "type": "integer", "format": "int64" }, "messageId": { "type": "integer", "format": "int64" }, "name": { "type": "string" }, "groupId": { "type": "integer", "format": "int64" }, "groupName": { "type": "string" }, "selectionId": { "type": "integer", "format": "int64" }, "selectionName": { "type": "string" }, "channelId": { "type": "integer", "format": "int64" }, "channelName": { "type": "string" }, "externalId": { "type": "string" }, "messageCategoryId": { "type": "integer", "format": "int64" }, "messageCategoryName": { "type": "string" }, "message": { "$ref": "#/components/schemas/MessageBase" }, "trackingOverride": { "type": "integer", "format": "int64" } } }, "MessageBase": { "type": "object", "properties": { "subject": { "type": "string" }, "emailBodyText": { "type": "string" }, "emailBodyHtml": { "type": "string" }, "smsText": { "type": "string" }, "faxText": { "type": "string" }, "emailHeaders": { "type": "array", "items": { "$ref": "#/components/schemas/Attribute" } }, "attachments": { "type": "array", "items": { "$ref": "#/components/schemas/Attachment" } }, "attachmentReferences": { "type": "array", "items": { "$ref": "#/components/schemas/AttachmentReference" } }, "encoding": { "type": "string" }, "encodingSMS": { "type": "string" }, "imageHandlingMode": { "type": "string" } } }, "Attribute": { "type": "object", "properties": { "name": { "type": "string" }, "value": { "type": "string" } } }, "Attachment": { "type": "object", "properties": { "name": { "type": "string" }, "contentType": { "type": "string" }, "content": { "type": "string" } } }, "AttachmentReference": { "type": "object", "properties": { "contentId": { "type": "string" }, "reference": { "type": "string" } } } } } } ````